<div class="p-formgrid grid">
  <div class="col-12">
    <p-card *ngIf="parkingArea">
      <table>
        <thead>
          <tr>
            <th colspan="2" class="table-header">
              <div class="d-flex justify-content-between align-items-center">
                <span>{{ parkingArea.name }}</span>
              </div>
            </th>
          </tr>
        </thead>
        <tbody>
          <tr>
            <td>Name:</td>
            <td>{{ parkingArea.displayName }}</td>
          </tr>
          <tr>
            <td>Typ:</td>
            <td>{{ parkingArea.parkingType }}</td>
          </tr>
          <tr>
            <td>Status:</td>
            <td>{{ parkingArea.status }}</td>
          </tr>
          <tr>
            <td>Kapazität:</td>
            <td>{{ parkingArea.parkingCapacity.total }}</td>
          </tr>
          <tr>
            <td>Verfügbar:</td>
            <td>{{ parkingArea.parkingCapacity.remaining }}</td>
          </tr>

          <tr>
            <td>Adresse:</td>
            <td>
              <p class="m-0">
                {{ parkingArea.address.street }}
              </p>
              <p class="m-0">
                {{ parkingArea.address.postalCode }}
                {{ parkingArea.address.city }}
              </p>
              <a
                [href]="generateGoogleMapsUrl(parkingArea.coordinates)"
                [title]="parkingArea.name"
                target="_blank"
                >Link zu Google Maps</a
              >
            </td>
          </tr>
          <tr>
            <td>Reguläre Öffnungszeiten:</td>
            <td>
              <div class="d-flex justify-content-between align-items-start">
                <ul *ngIf="openingHoursList.length > 0; else noOpeningHours">
                  <li *ngFor="let hours of openingHoursList">
                    {{ hours.day }}:
                    <span *ngIf="hours.isAllDay"> Ganztägig geöffnet </span>
                    <span *ngIf="!hours.isAllDay && hours.from && hours.to">
                      {{ hours.from }} - {{ hours.to }}
                    </span>
                    <span *ngIf="!hours.from || !hours.to"> Geschlossen </span>
                  </li>
                </ul>
                <ng-template #noOpeningHours
                  >Keine Öffnungszeiten verfügbar.</ng-template
                >
              </div>
              <button
                *urboCmsUiHasPermission="Permission.ParkingAreaWrite"
                pButton
                pRipple
                icon="pi pi-pencil"
                label="Bearbeiten"
                class="w-auto mt-1 small-edit-button"
                (click)="showRegularDialog()"
              ></button>
            </td>
          </tr>

          <tr>
            <td>Sonderöffnungszeiten:</td>
            <td>
              <div class="d-flex justify-content-between align-items-start">
                <ul
                  *ngIf="
                    specialOpeningHoursList.length > 0;
                    else noSpecialOpeningHours
                  "
                >
                  <li *ngFor="let entry of specialOpeningHoursList">
                    {{ entry.date }}:
                    <span *ngIf="entry.isAllDay">Ganztägig geöffnet</span>
                    <span *ngIf="entry.isClosed">Geschlossen</span>
                    <span
                      *ngIf="
                        !entry.isAllDay &&
                        !entry.isClosed &&
                        entry.from &&
                        entry.to
                      "
                    >
                      {{ entry.from }} - {{ entry.to }}
                    </span>
                  </li>
                </ul>
                <ng-template #noSpecialOpeningHours>
                  Keine ausserordentliche Öffnungszeiten verfügbar.
                </ng-template>
              </div>
              <button
                *urboCmsUiHasPermission="Permission.ParkingAreaWrite"
                pButton
                pRipple
                icon="pi pi-pencil"
                label="Bearbeiten"
                class="w-auto mt-1 small-edit-button"
                (click)="showSpecialDialog()"
              ></button>
            </td>
          </tr>
        </tbody>
      </table>
      <div class="p-3 d-flex justify-content-end"></div>
    </p-card>
  </div>
</div>

<urbo-cms-parking-edit-regular-times
  [openingHours]="parkingArea?.openingHours ?? DEFAULT_OPENING_HOURS"
  [parkingId]="parkingArea?.id ?? ''"
  (openingHoursUpdated)="onOpeningHoursUpdated($event)"
></urbo-cms-parking-edit-regular-times>

<urbo-cms-parking-edit-special-times
  [specialOpeningHours]="specialOpeningHoursMap"
  [parkingId]="parkingArea?.id ?? ''"
  (specialOpeningHoursUpdated)="onSpecialOpeningHoursUpdated($event)"
></urbo-cms-parking-edit-special-times>
